'Program obsugi wywietlacza VFD z interfejsem szeregowym
'typu CU165ECPB

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
       'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
       'o czstotliwoci oscylatora
       'taktujcego mikrokontroler
Config Pinb.3 = Output                                      'linia DATA jako wyjciowa
Config Pinb.4 = Output                                      'linia CLS jako wyjciowa
Config Pinb.5 = Output                                      'linia CS jako wyjciowa

Declare Sub Zapisz_vfd(byval Wart As Byte)
       'wysya bajt do wywietlacza
Declare Sub Il_cyfr(byval Il As Byte)                       'umoliwia wybr liczby cyfr
       'wywietlacza (od 9 do 16)
Declare Sub Jasn_zn(byval Js As Byte)                       'umoliwia wybr jasnoci
       'wiecenia znakw
Declare Sub Czest_ods(byval Czest As Byte)
       'umoliwia wybr czstotliwoci
       'odwieania wywietlacza
Declare Sub Poz_kurs(byval Poz As Byte)
       'ustawia kursor w zadanej
       'pozycji
Declare Sub Auto_incr(byval Auto As Byte)
       'wcza/wycza inkrementacje
       'kursora
Declare Sub Displ_on_off(byval Displ As Byte)
       'wcza/wycza wywietlacz
Declare Sub Wys_vfd(byval S As String)
       'wywietla podany jako
       'parametr cig znakw
Declare Sub Czysc()                                         'czyci wywietlacz oraz
       'ustawia kursor na pozycji 1
Declare Sub Pocz()                                          'ustawia kursor na pocztku
       'linii wywietlacza
Declare Sub Znak_uz(byval Nr_zn As Byte , Byval Kol1 As Byte , Byval Kol2 As Byte , Byval Kol3 As Byte , Byval Kol4 As Byte , Byval Kol5 As Byte)
       'umoliwia zdefiniowanie
       'wasnego znaku

Dim K As Byte                                               'zmienna licznikowa
Dim Kod As Byte                                             'zmienna przechowujca
       'kod znaku wysyanego do VFD
Dim J As Byte                                               'zmienna licznikowa

Cs Alias Portb.5                                            'przypisanie do linii PB5 (CS)
       'nazwy CS

Set Cs                                                      'zablokowanie komunikacji
       'z wywietlaczem
Waitms 100                                                  'opnienie 100 ms
Reset Cs                                                    'odblokowanie komunikacji
       'z wywietlaczem
Il_cyfr 16                                                  'liczba znakw 16
Czest_ods 0                                                 'czstotliwo odwieania
       'znakw 160 uS
Jasn_zn 3                                                   'poziom jasnoci wiecenia 3
Auto_incr 1                                                 'wczenie inkrementacji
       'kursora
Displ_on_off 1                                              'wczenie wywietlacza

'pocztek programu

Call Czysc                                                  'wyczyszczenie zawartoci VFD
Wys_vfd "**Bascom AVR**"                                    'wywietlenie napisu zawartego
       'w cudzysowiu
Wait 2                                                      'opnienie 2 sekundy
Poz_kurs 2                                                  'kursor na pozycj 2
Wys_vfd "!"                                                 'wywietlenie na pozycji 2
       'znaku !
Poz_kurs 13                                                 'kursor na pozycj 13
Wys_vfd "!"                                                 'wywietlenie na pozycji 13
       'znaku !
Wait 2                                                      'opnienie 2 sekundy
For K = 1 To 8                                              'ptla wykonywana 8 razy
 Jasn_zn K                                                  'zmiana poziomu jasnoci
       'wywietlacza od 1 do 8
 Waitms 500                                                 'z opnieniem 500 ms
Next K
Wait 2                                                      'opnienie 2 sekundy
Displ_on_off 0                                              'wyczenie wywietlacza
Wait 2                                                      'opnienie 2 sekundy
Displ_on_off 1                                              'wczenie wywietlacza
Wait 2                                                      'opnienie 2 sekundy
Poz_kurs 1                                                  'kursor na pozycje 1
Auto_incr 0                                                 'wyczenie inkrementacji
       'kursora
Wys_vfd "AVR"                                               'wywietlenie tekstu AVR
Wait 2                                                      'opnienie 2 sekundy
Call Czysc                                                  'wyczyszczenie VFD
Znak_uz 0 , 0 , 255 , 0 , 255 , 0                           'zdefiniowanie pierwszego
       'wasnego znaku - dwie pionowe
       'kreski
Zapisz_vfd 144                                              'wywietlenie zdefiniowanego
       'znaku na pozycji 0 VFD
End                                                         'koniec programu


Sub Displ_on_off(byval Displ As Byte)                       'definicja procedury
 If Displ < 4 Then                                          'jeli Displ < 4, to
  Displ = Displ + &B11110000                                'do zawartoci Displ dodanie
       'komendy sterujcej
       'wczaniem/wyczaniem VFD
  Call Zapisz_vfd(displ)                                    'wysanie wartoci Displ do VFD
 End If
End Sub                                                     'koniec procedury

Sub Auto_incr(byval Auto As Byte)                           'definicja procedury, ktra
       'wcza/wycza inkrementowanie
       'kursora
 If Auto < 2 Then                                           'jeli warto Auto < od 2, to
  Auto = Auto + &B11110100                                  'dodanie do niej wartoci kodu
       'komendy inkrementowania kursora
  Call Zapisz_vfd(auto)                                     'wysanie wartoci Auto do VFD
 End If
End Sub                                                     'koniec procedury

Sub Poz_kurs(byval Poz As Byte)                             'definicja procedury, ktra
       'okrela pozycj kursora
 Decr Poz                                                   'zmniejszenie o jeden wartoci
       'parametru Poz
 If Poz < 16 Then                                           'jeli Poz < od 17, to
  Poz = Poz + &B11100000                                    'dodanie do wartoci Poz kodu
       'komendy okrelajcej pozycj
  Call Zapisz_vfd(poz)                                      'wysanie wartoci Poz do VFD
 End If
End Sub                                                     'koniec procedury

Sub Czest_ods(byval Czest As Byte)                          'definicja procedury, ktra
       'okrela czstotliwo
       'odwieania VFD
 If Czest < 2 Then                                          'jeli otrzymana warto Czest
       '< od 2, to
  Czest = Czest + &B11110110                                'dodanie do wartoci Czest
       'kodu komendy okrelajcej
       'czstotliwo odwieania
  Call Zapisz_vfd(czest)                                    'wysanie wartoci Czest do VFD
 End If
End Sub                                                     'koniec procedury

Sub Jasn_zn(byval Js As Byte)                               'definicja procedury, ktra
       'okrela jasno wywietlanych
       'znakw
 Decr Js                                                    'zmniejszenie o jeden wartoci Js
 If Js < 8 Then                                             'jeli otrzymana warto Js <
       'od 8, to
  Js = Js + &B00001000                                      'dodanie do wartoci Js kodu
       'komendy okrelajcej jasno
       'znakw VFD
  Call Zapisz_vfd(js)                                       'wysanie wartoci Js do VFD
 End If
End Sub                                                     'koniec procedury

Sub Il_cyfr(byval Il As Byte)                               'definicja procedury, ktra
       'okrela liczb znakw VFD
 If Il < 17 Then                                            'jeli otrzymana warto Il
       '< od 17, to
  Il = Il - 9                                               'odjcie od niej wartoci 9,
       'aby jej warto wysana do
       'VFD bya z zakresu od 0 do 7
  Call Zapisz_vfd(il)                                       'wysanie wartoci Il do Vfd
 End If
End Sub                                                     'koniec procedury

Sub Zapisz_vfd(byval Wart As Byte)                          'definicja procedury, ktra
       'wysya szeregowo warto do
       'wywietlacza VFD
 Shiftout Portb.3 , Portb.4 , Wart , 1
       'wysya zawarto zmiennej
       'Wart do VFD poczwszy od
       'najbardziej znaczcego bitu
End Sub                                                     'koniec procedury

Sub Pocz()                                                  'definicja procedury, ktra
       'ustawia kursor na pocztku
       'linii VFD
  Poz_kurs 1                                                'wywoanie procedury
       'ustawiajcej kursor na 1
       'pozycji VFD
End Sub                                                     'koniec procedury

Sub Czysc()                                                 'definicja procedury, ktra
       'czyci zawarto VFD
 For J = 1 To 16                                            'ptla wykonywana 16 razy
  Poz_kurs J                                                'pozycja kursora na pozycj
       'zawart w J
   Zapisz_vfd 32                                            'zapisanie na pozycji
       'wskazywanej przez J znaku
       'spacji
 Next J                                                     'zwikszenie J o 1
 Call Pocz                                                  'kursor na pocztek linii
End Sub                                                     'koniec procedury

Sub Wys_vfd(byval S As String)                              'definicja procedury, ktra
       'wywietla podany jako
       'parametr acuch tekstu
 Local Dl As Byte                                           'lokalna zmienna okrelajca
       'dugo tekstu w acuchu
 Local Znak As String * 20                                  'lokalna zmienna tekstowa do
       'ktrej bdzie zapisywany
       'pojedynczy znak z acucha
       'tekstu
 Dl = Len(s)                                                'zwraca dugo tekstu ze
       'zmiennej S do zmiennej Dl
 For J = 1 To Dl                                            'ptla tyle razy wykonana si,
       'ile jest znakw w acuchu
       'tekstu
  Znak = Mid(s , J )                                        'zapisanie do zmiennej Znak
       'jednego znaku z tekstu S
       'o pozycji okrelonej przez J
  Kod = Asc(znak)                                           'zamiana znaku w zmiennej Znak
       'na jej kod ASCII zapisywany
       'w zmiennej Kod
  Zapisz_vfd Kod                                            'wysanie kodu ASCII znaku do
       'wywietlacza VFD
 Next J                                                     'zwikszenie o 1 wartoci J
End Sub                                                     'koniec procedury

Sub Znak_uz(byval Nr_zn As Byte , Byval Kol1 As Byte , Byval Kol2 As Byte , Byval Kol3 As Byte , Byval Kol4 As Byte , Byval Kol5 As Byte)       'definicja procedury, ktra
       'definiuje znak uytkownika
 Call Zapisz_vfd(255)                                       'wysanie komendy definiowania
       'nowego znaku
 If Nr_zn < 16 Then                                         'jeli Nr_zn jest < od 16, to
  Call Zapisz_vfd(nr_zn)                                    'zapisanie numeru znaku do VFD
  Call Zapisz_vfd(kol1)                                     'zapisanie kodu kolumny 1
       'znaku do VFD
  Call Zapisz_vfd(kol2)                                     'zapisanie kodu kolumny 2
       'znaku do VFD
  Call Zapisz_vfd(kol3)                                     'zapisanie kodu kolumny 3
       'znaku do VFD
  Call Zapisz_vfd(kol4)                                     'zapisanie kodu kolumny 4
       'znaku do VFD
  Call Zapisz_vfd(kol5)                                     'zapisanie kodu kolumny 5
       'znaku do VFD
 End If
End Sub                                                     'koniec procedury
