'Program  obsugi jednego ukadu DS1820 doczonego
'do magistrali 1-Wire

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
      'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
      'o czstotliwoci oscylatora
      'taktujcego mikrokontroler
Config Lcd = 16 * 2                                         'konfiguracja typu wywietlacza
      'LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 ,   Db7 = Portc.0 , E = Portc.4 ,   Rs = Portc.5                                               'konfiguracja linii
      'mikrokontrolera do ktrych
      'doczono wywietlacz
      'LCD
Config 1wire = Portb.0                                      'konfiguracja linii magistrali
      '1-Wire
Declare Sub Odcz_temp                                       'procedura odczytu temperatury
      'z ukadu DS1820
Dim Temperatura(2) As Byte                                  'tablica dwch zmiennych typu
      'Byte do pamitania wartoci
      'temperatury
'definicja znaku stopnia
Deflcdchar 0 , 7 , 5 , 7 , 32 , 32 , 32 , 32 , 32

Do                                                          'pocztek ptli programu
 Call Odcz_temp                                             'wywoanie procedury pomiaru
      'temperatury
 Cls                                                        'czyszczenie ekranu LCD
 If Temperatura(2) = 0 Then                                 'jeli warto Temperatura(2)=
      '=0, to temperatura dodatnia
      'wywietla temperatury dodatnie
  Lcd "Temp: " ; Temperatura(1) ; Chr(0) ; "C"
 Else                                                       'w przeciwnym razie
      'wywietla temperatury ujemne
  Lcd "Temp: -" ; Temperatura(1) ; Chr(0) ; "C"
 End If
Loop                                                        'koniec ptli Do...Loop
End                                                         'koniec programu

Sub Odcz_temp                                               'definicja procedury pomiaru
      'temperatury
 1wreset                                                    'reset magistrali 1-Wire
 1wwrite &HCC                                               'opuszczenie zapisu numeru ID
 1wwrite &H44                                               'start pomiaru temperatury
 Waitms 750                                                 'opnienie na czas pomiaru
 1wreset                                                    'reset magistrali 1-Wire
 1wwrite &HCC                                               'opuszczenie zapisu numeru ID
 1wwrite &HBE                                               'komenda odczytu zmierzonej
      'temperatury
 Temperatura(1) = 1wread(2)                                 'odczyt zmierzonej temperatury
      'do tablicy Temperatura
 1wreset                                                    'reset magistrali 1-Wire
 If Err = 1 Then                                            'jeli ukad doczony do
      'magistrali nie odpowiada, to
  Cls                                                       'czyszczenie LCD
  Lcd "Brak ukladu"                                         'wywietlenie komunikatu o braku
      'doczonego ukadu
  Do                                                        'nieskoczona ptla w celu
      'wstrzymania dziaania programu
  Loop
 End If
 If Temperatura(2) > 0 Then                                 'jeli zmienna Temperatura(2)
      '> 0, to temperatura ujemna
      'przeliczenie temperatury
      'ujemnej
  Temperatura(1) = 256 - Temperatura(1)
 End If                                                     'koniec warunku
 Temperatura(1) = Temperatura(1) / 2
      'dalsze przeliczenie odczytanej
      'temperatury dodatniej jak
      'i ujemnej
End Sub                                                     'koniec procedury pomiaru
