'Program obsugi przyciskw S1, S2 za pomoc instrukcji Debounce

$REGFILE = "m8def.dat"				'informuje kompilator o pliku
						'dyrektyw mikrokontrolera
$CRYSTAL = 8000000 				'informuje kompilator 
						'o czstotliwoci oscylatora
						'taktujcego mikrokontroler
Config Pinb.1 = Input				'linia PB1 jako wejciowa
Config Pinb.2 = Input				'linia PB2 jako wejciowa
Config Pinb.4 = Output				'linia PB4 jako wyjciowa
Config Pinb.5 = Output				'linia PB5 jako wyjciowa

Led1 Alias Portb.5				'przypisanie nazwie Portb.5 
						'nazwy Led1
Led2 Alias Portb.4				'przypisania nazwie Portb.4 
						'nazwy Led2
S1 Alias Pinb.2					'przypisanie nazwie Pinb.2 
						'nazwy S1
S2 Alias Pinb.1					'przypisanie nazwie Pinb.1 
						'nazwy S2

Set Portb.1					'doczenie do linii PB1 
						'rezystora podcigajcego
Set Portb.2					'doczenie do linii PB2 
						'rezystora podcigajcego

Do						'nieskoczona ptla Do...Loop
	Debounce S1 , 0 , Pr1 , Sub		'jeli naciniety przycisk S1, 
						'to skok do podprogramu Pr1
	Debounce S2 , 0 , Pr2 , Sub		'jeli nacinity przycisk S2, 
						'to skok do podprogramu Pr2
Loop

End						'koniec programu

Pr1:						'podprogram Pr1
	Toggle Led1				'zmiana na przeciwny stanu 
						'wyjcia sterujcego diod D1
Return						'powrt z podprogramu

Pr2:						'podprogram Pr2
	Toggle Led2				'zmiana na przeciwny stanu 
						'wyjcia sterujcego diod D2
Return						'powrt z podprogramu

