'Program adowanego przez Bootloader
'Program ten realizuje migotanie diody doczonej do linii PB2
'oraz wywietla na LCD, w jego dwch liniach, tekst

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
      'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
      'o czstotliwoci oscylatora
      'taktujcego mikrokontroler
Config Pinb.1 = Input                                       'linia PB1 jako wejciowa
Config Pinb.2 = Output                                      'linia PB2 jako wyjciowa
Config Lcd = 16 * 2                                         'konfigurowanie typu
      'wywietlacza LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfigurowanie linii
      'mikrokontrolera, do ktrych
      'jest doczony wywietlacz LCD
Led Alias Portb.2                                           'przypisanie nazwie Portb.2
      'nazwy Led
S1 Alias Pinb.1                                             'przypisanie nazwie Pinb.1
      'nazwy S1

Set Portb.1                                                 'doczenie do linii PB1
      'rezystora podcigajcego
Cls                                                         'czyszczenie LCD
Lcd "Bascom AVR"                                            'wywietlenie napisu na
      'pierwszej linii LCD
Lowerline                                                   'przeniesienie kursora do
      'drugiej linii LCD
Lcd "Bootloader ok!!!"                                      'wywietlenie napisu w drugiej
      'linii LCD
Do                                                          'nieskoczona ptla Do...Loop
 Toggle Led                                                 'zmiana stanu linii PB2 na
      'przeciwny
 If S1 = 0 Then                                             'jeli nacinity przycisk S1,
      'to
  Waitms 25                                                 'opnienie 25 ms dla eliminacji
      'drga stykw
  If S1 = 0 Then                                            'sprawdzenie ponownie, czy S1
      'naciniety, jeli tak, to
   JMP $F80                                                 'skok do programu Bootloadera
  End If                                                    'koniec warunkw
 End If
 Waitms 200                                                 'opnienie 200 ms
Loop                                                        'koniec nieskoczonej ptli
End                                                         'koniec programu
